// configurable.C

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/


#ifdef __GNUG__
#pragma implementation
#endif

#include "localdefs.h"
#include "configurable.h"
#include "requester.h"

Status
Configurable::configure(Controller *c) {
	boolean status = Fail;
	if(ok() && !isConfigured()) {
		Requester* req = createRequester();
		if(req && req->queryForValues(c))
			initialize(); // this can fail and reset ok() to false
		delete req;
	}
	return isConfigured() ? Succeed : Fail;
}

Status
Configurable::reconfigure(Controller *c) {
	configured = false;
	return configure(c);
}
