// contscroller.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/


// A modification of ScrollerBar to allow continuous scrolling with any mouse
// button held down.  This will be used with the AdjustibleNumber objects in
// a new InputDialog implementation.

#ifndef CONTSCROLLER_H
#ifdef __GNUG__
#pragma interface
#endif
#define CONTSCROLLER_H

#include "scroller.h"

class Event;

class ContinuousScroller : public ScrollerBar {
	typedef ScrollerBar Super;
public:
	ContinuousScroller(Interactor *i, int h = 20) : ScrollerBar(i, h) {}
    ContinuousScroller(const char *name, Interactor *i, int h = 20)
		: ScrollerBar(name, i, h) {}
	virtual ~ContinuousScroller() {}
	
	redefined void Handle(Event&);
protected:
    redefined void Reconfig();
};

#endif
