// datatype.C

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif

#include <math.h>
#include "datatype.h"
#include "sndconfig.h"

const DataType::TypeInfo
DataType::typeInfo[] = {
//		bits	bytes	format			name
	{	0,		0,		0,				"unknown type" },
	{	8,		1,		CHAR_FORMAT,	"8-bit linear" },
	{	8,		1,		CHAR_FORMAT,	"8-bit unsigned" },
	{	8,		1,		ALAW_FORMAT,	"8-bit a-law" },
	{	8,		1,		MULAW_FORMAT,	"8-bit u-law" },
	{	16,		2,		SHORT_FORMAT,	"16-bit linear" },
	{	32,		4,		INT_FORMAT,		"32-bit integer" },
	{	32,		4,		FLOAT_FORMAT,	"floating point" },
	{	64,		8,		DOUBLE_FORMAT,	"double precision float" }
};

DataType::DataType(int itype) : typeIndex(0) {
	if(itype == 0) typeIndex = 0;
	while(itype > 1) { itype >>=1;  typeIndex++; }
}

DataType::operator int () {
	return (typeIndex == 0) ? 0 : int(pow(2.0, typeIndex - 1));
}

