// ieee_float.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif

class IEEE_Float {
public:
	IEEE_Float(double value);
	IEEE_Float(const IEEE_Float &);
	operator const char * () const { return chars; }
	operator float () const;
	operator double () const;
	const IEEE_Float& operator = (const IEEE_Float &);
	double operator = (double);
private:
	void setTo(double);
	static void ConvertToIeeeExtended(double, char *);
	static double ConvertFromIeeeExtended(const unsigned char *);
private:
	char chars[10];
};
