// margin.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/


// Encapsulation of the four edge spacings for the BorderedArea class (see
// scaledarea.h).

#ifndef MARGIN_H
#define MARGIN_H

class Margin {
public:
	Margin(int t=0, int b=0, int l=0, int r=0) 
		: top(t), bottom(b), left(l), right(r) {}
	void set(int t, int b, int l, int r) {
		top = t; bottom = b; left = l; right = r;
	}
	int top, bottom, left, right;
};

#endif
