// pipeaction.h

/******************************************************************************
 *
 *  MiXViews - an X window system based sound & data editor/processor
 *
 *  Copyright (c) 1993, 1994 Regents of the University of California
 *
 *  Author:     Douglas Scott
 *  Date:       December 13, 1994
 *
 *  Permission to use, copy and modify this software and its documentation
 *  for research and/or educational purposes and without fee is hereby granted,
 *  provided that the above copyright notice appear in all copies and that
 *  both that copyright notice and this permission notice appear in
 *  supporting documentation. The author reserves the right to distribute this
 *  software and its documentation.  The University of California and the author
 *  make no representations about the suitability of this software for any 
 *  purpose, and in no event shall University of California be liable for any
 *  damage, loss of data, or profits resulting from its use.
 *  It is provided "as is" without express or implied warranty.
 *
 ******************************************************************************/
// PipeAction is an abstract base class for the encapsulation of methods which
// load double values into the input and output queues of Input- and
// OutputFunction subclasses

#ifndef PIPEACTION_H
#define PIPEACTION_H

#include <InterViews/resource.h>

class InPipeAction : public Resource {
public:
	virtual int add(double) = 0;	// returns false when queue is full
};

class OutPipeAction : public Resource {
public:
	virtual double take() = 0;		// returns value from queue
};

#endif
